package mi.hdm;

import javafx.application.Application;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import mi.hdm.controllers.View;
import mi.hdm.recipes.*;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.IOException;
import java.util.List;
import java.util.Map;

public class TastyPages extends Application {
    //TODO: instantiate all dependencies HERE! The getScene() method from View.java should go here as well for dependency injection
    public final static RecipeManager recipeManager = new RecipeManager();

    private final static Logger log = LogManager.getLogger(TastyPages.class);
    private static Stage stage;

    public static void main(String[] args) {
        log.info("Starting TastyPages");

        recipeManager.addRecipe(new Recipe("Mein erstes Rezept", Map.of(new Ingredient(Measurement.GRAM, "Mehl", new NutritionTable(100, 20, 8, 14, 2.5, 3)), 100), "Description", List.of("joa"), List.of(), 40));
        recipeManager.addRecipe(new Recipe("Mein letztes Rezept", Map.of(new Ingredient(Measurement.GRAM, "Zucker", new NutritionTable(100, 500, 8, 14, 2.5, 3)), 100), "Description", List.of("joa"), List.of(), 40));

        launch(args);
    }

    public static Stage getApplicationStage() {
        return stage;
    }

    @Override
    public void start(Stage stage) throws IOException {
        TastyPages.stage = stage;

        Parent parent = View.MAIN.getScene();
        final Scene scene = new Scene(parent, 1400, 800);

        stage.setTitle(View.MAIN.getWindowTitle());
        stage.setMaximized(true); //open scene in full screen
        stage.setScene(scene);
        stage.show();
    }
}
