package mi.hdm.controllers;

import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import mi.hdm.TastyPages;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.IOException;

public abstract class BaseController {
    private final static Logger log = LogManager.getLogger(BaseController.class);
    private final static Stage stage = TastyPages.getApplicationStage();

    protected Scene currentScene;

    protected void changeScene(final View newScene) throws IOException {
        boolean wasMaximized = stage.isMaximized();
        double sizeX = stage.getWidth();
        double sizeY = stage.getHeight();
        String newWindowTitle = newScene.getWindowTitle();

        log.debug("Attempting to change the scene to {}", newScene);
        Parent newParent = newScene.getScene();

        currentScene = new Scene(newParent, sizeX, sizeY);

        stage.setTitle(newWindowTitle);
        stage.setScene(currentScene);
        stage.setMaximized(wasMaximized);
    }
}
